!
!  SPDX-License-Identifier: GPL-3.0-or-later
!  Copyright (C) 2019-2022, respective authors of MCFM.
!
c==== this routine generated by C.W using Mathematica, should
c===== be checked by RKE's LaTeX script.
      function AGTYE4s(t,u,Lx,Ly,Ls)
      implicit none
c     Results taken from hep-ph/0201274
c  C.~Anastasiou, E.~W.~N.~Glover and M.~E.~Tejeda-Yeomans,
c     Eq. A.10
      include 'types.f'
      real(dp):: AGTYE4s,E4sx
      real(dp):: t,u,Lx,Ly,Ls
      AGTYE4s=E4sx(t,u,Lx,Ly,Ls)
     &       +E4sx(u,t,Ly,Lx,Ls)
      return
      end


      function E4sx(t,u,Lx,Ly,Ls)
      implicit none
      include 'types.f'
      real(dp):: E4sx
      include 'constants.f'
      include 'zeta.f'
      real(dp)::t,u,Lx,Ly,Ls

      E4sx=(-152._dp*Lx)/9._dp+(32._dp*Ls*Lx)/3._dp
     & -(104._dp*Lx**2)/9._dp+
     & (32._dp*Ls*Lx**2)/3._dp+(32._dp*Lx**3)/9._dp+(64*pisq)/9._dp+
     & (128._dp*Lx*pisq)/9._dp+
     & (t*(41.98765432098765_dp-(908._dp*Ls)/27._dp-
     & (152._dp*Lx**2)/9._dp+(32._dp*Ls*Lx**2)/3._dp+
     & (32._dp*Lx**3)/9._dp-20._dp*Ly+16._dp*Ls*Ly-(4._dp*Ly**2)/9._dp+
     & (16._dp*Ls*Ly**2)/3._dp+(16._dp*Ly**3)/9._dp+
     & (110*pisq)/9._dp-(2._dp*Ls*pisq)/3._dp+
     & (128._dp*Lx*pisq)/9._dp+(64._dp*Ly*pisq)/9._dp-(4*zeta3)/9._dp)
     & )/u
      return
      end

